"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnprocessableEntity = exports.InternalServerError = exports.BadRequest = exports.NotFound = exports.TooManyRequests = exports.UnsupportedMediaType = exports.Unauthorized = exports.BaseError = void 0;
class BaseError extends Error {
    constructor(message, statusCode, type, context) {
        super(message);
        this.type = type;
        this.statusCode = statusCode;
        this.context = context;
    }
}
exports.BaseError = BaseError;
class Unauthorized extends BaseError {
    constructor(message, context) {
        super(message, '401', 'Unauthorized', context);
    }
}
exports.Unauthorized = Unauthorized;
class UnsupportedMediaType extends BaseError {
    constructor(message, context) {
        super(message, '415', 'UnsupportedMediaType', context);
    }
}
exports.UnsupportedMediaType = UnsupportedMediaType;
class TooManyRequests extends BaseError {
    constructor(message, context) {
        super(message, '429', 'TooManyRequests', context);
    }
}
exports.TooManyRequests = TooManyRequests;
class NotFound extends BaseError {
    constructor(message, context) {
        super(message, '404', 'NotFound', context);
    }
}
exports.NotFound = NotFound;
class BadRequest extends BaseError {
    constructor(message, context) {
        super(message, '400', 'BadRequest', context);
    }
}
exports.BadRequest = BadRequest;
class InternalServerError extends BaseError {
    constructor(message, context) {
        super(message, '500', 'InternalServerError', context);
    }
}
exports.InternalServerError = InternalServerError;
class UnprocessableEntity extends BaseError {
    constructor(message, context) {
        super(message, '422', 'UnprocessableEntity', context);
    }
}
exports.UnprocessableEntity = UnprocessableEntity;
