import winston from 'winston';
import { IndexedData, Logger } from './Logger';
import { RequestContextRegistry } from '../RequestContextRegistry';
export declare class StructuredLogger<T extends IndexedData = IndexedData> implements Logger<T> {
    protected requestContextRegistry: RequestContextRegistry;
    protected indexablePropertiesOverride?: Record<string, "string" | "number"> | undefined;
    constructor(requestContextRegistry: RequestContextRegistry, indexablePropertiesOverride?: Record<string, "string" | "number"> | undefined);
    protected logger: winston.Logger;
    indexLogProperties(message: any, indexableProperties: Record<string, 'string' | 'number'>): Record<string, any>;
    log(log: T | string | number | null): void;
    info(log: T | string | number | null): void;
    debug(log: T | string | number | null): void;
    warn(log: T | string | number | null): void;
    error(log: T | string | number | null): void;
}
